/* Part4a */
/******************************************************************************
PURPOSE:	This is part 4a of assignment 3.  The purpose of the program 
		is to broadcast a message via MPI_COMM_WORLD and then wait 
		for all the other processors to send the message back
AUTHOR:		Marjorie Quant
CLASS:		CPS 615 -- Computational Science for Simulation
*******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>





void main (int argc, char *argv[])
{
  int ierror, rank , p;
  int buffer = 1000;
  int ping = 101;
  int *pong;
  double start, finish, total_time;
  MPI_Status status;  
  MPI_Request request;
  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  MPI_Comm_size(MPI_COMM_WORLD, &p);
  
  pong = (int*)malloc(sizeof(int)*p);

  if (rank ==0 )
    start = MPI_Wtime();

  MPI_Bcast(&ping, 1, MPI_INT, 0, MPI_COMM_WORLD);
  MPI_Gather(&ping, 1, MPI_INT, &pong[0], 1, MPI_INT, 0, MPI_COMM_WORLD);

  if (rank ==0 )
  {
    finish = MPI_Wtime();
    total_time = finish - start;
    printf("Total Time\n");
    printf("%d\t", total_time);
  }

  MPI_Finalize();

} /* end of main */






